#include <bit>
#include <iostream>
using namespace std;

union IntFloat {
  int intzahl;
  float floatzahl;
};

union Union2 {
  int wert;
  IntFloat einIntFloat;
};

int main()
{
  IntFloat eineUnion;                    // undefinierter Inhalt
  eineUnion.intzahl = 42;                // Speicherplatz belegen
  cout << eineUnion.intzahl << '\n';     // gespeicherten Wert verwenden
  eineUnion.floatzahl = 0.987f;          // denselben Speicherplatz belegen
  // eineUnion.floatzahl ist jetzt aktives Element
  cout << eineUnion.floatzahl << '\n';   // ... und verwenden
  cout << &eineUnion.intzahl << '\n'     // Ausgabe der Adressen
       << &eineUnion.floatzahl << '\n';  // muss gleich sein
  // Fehler: union-Missbrauch zur Typumwandlung (engl. type punning)
  cout << eineUnion.intzahl << '\n';   // Interpretation eines float-Bitmusters als int
  // seit C++20 gibt es bit_cast für solche Zwecke:
  const auto floatAlsInt = bit_cast<int>(eineUnion.floatzahl);
  cout << "float als int: " << floatAlsInt << '\n'; 
}

