#include <cstddef>
#include <iostream>
#include <string>                       // Standard-String einschließen
using namespace std;
int main()        // Programm mit typischen String-Operationen
{
  // String-Objekt einString anlegen und mit " hallo" initialisieren.
  string einString {"hallo"};             // einString kann ein beliebiger Name sein.
  cout << einString << '\n';              // String ausgeben

  // Beim Vektor wäre stattdessen für die Ausgabe  eine Schleife notwendig.
  // Die Anzahl der Zeichen kann bei Strings mit length() ermittelt werden.
  // String zeichenweise ausgeben, ungeprüfter Zugriff wie bei vector:
  for (size_t i = 0; i < einString.length(); ++i) {
    cout << einString[i];
  }
  cout << '\n';
  // String zeichenweise mit Indexprüfung ausgeben.
  for (size_t i = 0; i < einString.length(); ++i) {
    cout << einString.at(i);
  }
  cout << '\n';
  // Die Prüfung geschieht wie beim Vektor. Ein Versuch, einString.at(i)
  // mit i >= einString.size() abzufragen, führt zum Programmabbruch mit Fehlermeldung.
  string eineStringKopie(einString);    // Kopie des Strings einString erzeugen
  cout << eineStringKopie << '\n';      // hallo
  const string diesIstNeu{"neu!"};      // andere Initialisierung einer Kopie
  eineStringKopie = diesIstNeu;         // Kopie durch Zuweisung
  cout << eineStringKopie << '\n';      // neu!
  eineStringKopie = "Buchstaben";       // Zuweisung einer Zeichenkette
  cout << eineStringKopie << '\n';      // Buchstaben
  einString = 'X';                      // Zuweisung nur eines Zeichens vom Typ char
  cout << einString << '\n';            // X
  einString += eineStringKopie;         // Strings mit dem +=-Operator verketten
  cout << einString << '\n';            // XBuchstaben
  einString = eineStringKopie + " ABC"; // Strings mit dem +-Operator verketten
  cout << einString << '\n';            // Buchstaben ABC
  einString = "123" + eineStringKopie;
  cout << einString << '\n';            // 123Buchstaben
  // einString = "123" + " ABC";          geht nicht! Erklärung folgt in Kapitel 8
   einString = string("123") + "ABC";    // ok!

  // Vergleich von Strings
  const string a{"Albert"};
  const string b{a};
  if (a == b) {
    cout << a << " == " << b << '\n';
  }
  else {
    cout << a << " != " << b << '\n';
  }
  const string z{"Alberta"};
  if (a < z) {
    cout << a << " < " << z << '\n';
  }
  if (z > a) {
    cout << z << " > " << a << '\n';
  }
  if (z != a) {
    cout << z << " != " << a << '\n';
  } 
  const string str{'a', 'b', 'c'};      // String mit Initialisierungsliste  {'a', 'b', 'c'}
  cout << "mit Initialisierungsliste erzeugter String:" << str << '\n';
} // Ende von main()

