#include <iostream>
using IteratorType = const int*;      // neuer Typname für Zeiger auf const int

// Prototyp des Algorithmus
[[nodiscard]] IteratorType find(IteratorType begin, IteratorType end, int wert);

int main()
{
  constexpr int anzahl{100};
  int einContainer[anzahl];                  // Container definieren
  IteratorType begin{einContainer};          // Zeiger auf den Anfang
  IteratorType end{einContainer + anzahl};   // Position nach dem letzten Element

  // Container mit beliebigen Werten füllen (hier: gerade Zahlen)
  for (int i = 0; i < anzahl; ++i) {
    einContainer[i] = 2 * i;
  }

  int zahl{0};
  while (zahl != -1) {
    std::cout << " gesuchte Zahl eingeben (-1 = Ende):";
    std::cin >> zahl;
    if (zahl != -1) {                        // weitermachen?
      IteratorType position = find(begin, end, zahl);
      if (position != end) {
        std::cout << "gefunden an Position " << (position - begin) << '\n';
      }
      else {
        std::cout << zahl << " nicht gefunden!\n";
      }
    }
  }
}

// Implementation
IteratorType find(IteratorType begin, IteratorType end, int wert)
{
  while (begin != end                  // Zeigervergleich
         && *begin != wert) {          // Dereferenzierung und Objektvergleich
    ++begin;                           // nächste Stelle
  }
  return begin;
}

