#include <ranges>
#include <iostream>
#include <vector>
#include <showContainer.h>

[[nodiscard]] bool ungerade(int i) { return i % 2 != 0; }
[[nodiscard]] int quadrat(int i) { return i*i; }

int main()
{
  const std::vector<int> vec { 10, 1, 6, 1, 7, 7, 2, 9, 12, 3};
  std::cout << "Ausgangsvektor: ";
  showContainer(vec);
  auto view1 = vec | std::views::filter(ungerade);
  std::cout << "Ungerade Zahlen: ";
  showContainer(view1);
  auto view2 = view1 | std::views::transform(quadrat);
  std::cout << "Deren Quadrate:  ";
  showContainer(view2);
  std::cout << "Beide Filter in der for-Schleife: ";
  for (int i : vec  | std::views::filter(ungerade)
         | std::views::transform(quadrat)) {
    std::cout << i << ' ';
  }
  std::cout << "\nUmgekehrte Reihenfolge: ";
  auto view3 = view2 | std::views::reverse;
  showContainer(view3);
  std::cout << "Die ersten drei fallen lassen: ";
  auto view4 = view3 | std::views::drop(3);
  showContainer(view4);
  std::cout << "Mit Iterator ausgeben: ";
  for(auto iter = view4.begin(); iter != view4.end(); ++iter) {
    std::cout << *iter << ' ';
  }
  std::cout << '\n';
}
