#ifndef LISTE_H
#define LISTE_H
#include <cstddef>
#include <iterator>
// Unvollständig! (nur für das Beispiel notwendige Funktionen sind implementiert). 
// Siehe auch Übungsaufgaben.
template <typename T>
class Liste {
public:
  // Kopierkonstruktor, Destruktor und Zuweisungsoperator fehlen! (Aufgaben)
  // push_front() erzeugt ein neues Listenelement und fügt es am Anfang der Liste ein:
  void push_front(const T& wert) 
  { 
    anfang = new ListElement(wert, anfang); 
  }
private:
  struct ListElement {
    T daten;
    ListElement* naechstes;
    ListElement(const T& wert, ListElement* p) 
      : daten{wert}, naechstes{p} 
    {}
  };
  ListElement* anfang{nullptr};

public:
  class Iterator {
  public:
    // von find() geforderte Schnittstelle:
    using iterator_category = std::forward_iterator_tag;
    using value_type = T;
    using pointer = T*;
    using reference = T&;
    using difference_type = std::ptrdiff_t;

    Iterator(ListElement* init = nullptr) 
      : aktuellesElement{init} 
    {}

    [[nodiscard]] const T& operator*() const               // Dereferenzierung
    {
      return aktuellesElement->daten;
    }

    Iterator& operator++()                   // Präfix
    {
      aktuellesElement = aktuellesElement->naechstes;
      return *this;
    }

    [[nodiscard]] Iterator operator++(int)    // Postfix
    {
      Iterator temp{*this};
      ++*this;
      return temp;
    }

    [[nodiscard]] bool operator==(const Iterator& x) const 
    { 
      return aktuellesElement == x.aktuellesElement; 
    }
    // operator!=() wird automatisch generiert.

 private:
    ListElement* aktuellesElement;           // Verweis auf aktuelles Element
  };                                         // Iterator
  //   Einige Methoden der Klasse Liste benutzen die Klasse Iterator:
  [[nodiscard]] Iterator begin() { return Iterator(anfang); }
  [[nodiscard]] Iterator end() { return Iterator(); }
};
#endif

