#ifndef EINFACHERSTRING_H
#define EINFACHERSTRING_H
#include <cstring>           // strlen()
#include <iostream>          // ostream
// Implementierung mit vector<char>, um new/delete zu vermeiden.
#include <vector>

class [[nodiscard]] StringTyp {
public:
  StringTyp(const char* s) 
  : v(s, s + std::strlen(s) + 1) 
  {}

  StringTyp(const StringTyp& s)
  : v(s.v)
  {
    static int anzahlAufrufe{0};
    std::cout << ++anzahlAufrufe << ". Aufruf des Kopierkonstruktors. Quelle = " << &s.v[0] << '\n';
  }

  StringTyp& operator=(StringTyp s)
  {
    swap(s);
    return *this;
  }

  StringTyp& operator+=(const StringTyp& s)
  {
    std::vector<char> temp(v.size() + s.v.size() - 1);
    std::copy(v.begin(), v.end(), temp.begin());                         // Teil 1 kopieren
    std::copy(s.v.begin(), s.v.end(), temp.begin() + std::ssize(v) - 1); // Teil 2 kopieren
    std::swap(temp, v);
    return *this;
  }
  [[nodiscard]] const char* c_str() const { return &v[0]; }          // C-String zurückgeben

private:
  std::vector<char> v;

  void swap(StringTyp& m) { std::swap(v, m.v); }
};

// neu
inline StringTyp operator+(StringTyp a, const StringTyp& b) { return a += b; }

#endif

