// hängende Referenz bis C++20
#include <iostream>
#include <string>

class Person {
public:
  Person(std::string n) : name{n} {}
  const auto& getName() const { return name; };  // Referenz!
  ~Person() { std::cerr << "Person-Destruktor gerufen\n"; }
private:
  std::string name {""};
};

int main()
{
  for (auto c : Person("Johann Christian Friedrich Hölderlin").getName()) {
    // Destruktor wird vor der ersten Ausgabe aktiv, daher ist die Referenz undefiniert
    std::cout << c;       // undefinierte Ausgabe vor C++23, allenfalls zufällig richtig
  }
  std::cout << '\n';
}
