#include "movingstring.h"
#include <iostream>

struct A {
  A(const StringTyp& a)                // per Referenz auf const
  : wert(a) {}                         // stets Kopie
  StringTyp wert;
};

struct B {
  B(StringTyp a)                       // per Wert
  : wert(std::move(a)) {}              // move bei R-Wert, sonst Kopie
  StringTyp wert;
};

int main()
{
  StringTyp lvalue("L-Wert");
  std::cout << "A (3 mal new)):\n";
  A einAL(lvalue);
  A einAR("R-Wert A");
  std::cout << einAL.wert << ' ' << einAR.wert << '\n';
  std::cout << "B (2 mal new)):\n";
  B einBL(lvalue);
  B einBR("R-Wert B");
  std::cout << einBL.wert << ' ' << einBR.wert << '\n';
}
