// Unterschied zu danglingref.cpp:
// Zwei Varianten von getName() mit Referenz-Qualifizierer
#include <iostream>
#include <string>

class Person {
public:
  Person(std::string n) : name{n} {}
  const auto& getName() const &  { return name; };   // Referenz!
  auto        getName() const && { return name; };   // Kopie!
  ~Person() { std::cerr << "Person-Destruktor gerufen\n"; }
private:
  std::string name{""};
};

int main()
{
  for (auto c : Person("Johann Christian Friedrich Hölderlin").getName()) {
    std::cout << c;
  }
  std::cout << '\n';
}
