#include "../move/movingstring.h"
#include <iostream>
#include <utility>

void tauschen(StringTyp& a, StringTyp& b)
{
  if (&a != &b) {
    auto tmp(std::move(a));          // bewegender Konstruktor
    a = std::move(b);                     // bewegender operator=()
    b = std::move(tmp);                   // bewegender operator=()
  }
}

void tauschen(StringTyp& a, StringTyp&& b)
{
  auto tmp(std::move(a));          // bewegender Konstruktor
  a = std::move(b);                     // bewegender operator=()
  b = std::move(tmp);                   // bewegender operator=()
}

void tauschen(StringTyp&& a, StringTyp& b)
{
  auto tmp(std::move(a));          // bewegender Konstruktor
  a = std::move(b);                     // bewegender operator=()
  b = std::move(tmp);                   // bewegender operator=()
}

int main()
{
  StringTyp a("einA");
  StringTyp b("einB");
  std::cout << " a = " << a << "   b = " << b << '\n';
  std::cout << "tauschen(&, &):\n";
  tauschen(a, b);
  std::cout << " a = " << a << "   b = " << b << '\n';
  std::cout << "tauschen(&, &&):\n";
  tauschen(a, StringTyp("temporaerB"));
  std::cout << " a = " << a << '\n';
  std::cout << "tauschen(&&, &):\n";
  tauschen(StringTyp("temporaerA"), b);
  std::cout << " b = " << b << '\n';
}
