#include "../move/movingstring.h"
#include <iostream>
#include <utility>

void vertauschen(StringTyp&& a, StringTyp&& b)
{
  auto tmp(std::move(a));               // bewegender Konstruktor
  a = std::move(b);                     // bewegender operator=()
  b = std::move(tmp);                   // bewegender operator=()
}

template <class T, class U>
void tauschen(T&& a, U&& b)
{
  vertauschen(std::move(a), std::move(b));
}

int main()
{
  StringTyp a("einA");
  StringTyp b("einB");
  std::cout << " a = " << a << "   b = " << b << '\n';
  std::cout << "tauschen(&, &):\n";
  tauschen(a, b);
  std::cout << " a = " << a << "   b = " << b << '\n';
  std::cout << "tauschen(&, &&):\n";
  tauschen(a, StringTyp("temporaerB"));
  std::cout << " a = " << a << '\n';
  std::cout << "tauschen(&&, &):\n";
  tauschen(StringTyp("temporaerA"), b);
  std::cout << " b = " << b << '\n';
}
