#include <algorithm>
#include <iostream>
#include <list>
#include <showContainer.h>                  // siehe Text
#include <type_traits>
#include <utility>                          // declval
#include <vector>

template <typename T, typename = void>      // void = Rückgabetyp von sort()
struct has_sort_function : std::false_type 
{};

template <typename T>
struct has_sort_function<T, decltype(std::declval<T>().sort())> : std::true_type 
{};

template <typename Container>
void sortiereContainer(Container& container)
{
  if constexpr (has_sort_function<Container>()) {
    std::cout << "Container.sort()\n";
    container.sort();
  }
  else {
    std::cout << "std::sort()\n";
    std::sort(container.begin(), container.end());
  }
}

int main()
{
  std::cout << std::boolalpha;
  std::cout << has_sort_function<std::list<int>>::value << '\n';
  std::cout << has_sort_function<std::vector<int>>::value << '\n';

  std::list<int> liste{3, 6, 8, 9, 1, 3, 0};
  std::vector<int> vektor{3, 6, 8, 9, 1, 3, 0};

  sortiereContainer(liste);
  showContainer(liste);
  sortiereContainer(vektor);
  showContainer(vektor);
}

