#include "RegexTester.h"
#include <array>
#include <iostream>

void testfaelle()
{
  constexpr std::array testfaelle {
    std::array{"^\\D+([0-9]+) \\1", "Sommer 2023 2023"},
    std::array{"[a-c]+", "zcbaaxcadey"},
    std::array{"\\t", "enthält  	Tabulator"},   // Tabulator
    std::array{"[a-c]*", "z"},                   // greedy
    std::array{"[^aeiou]+", "hallo"},
    std::array{"/\\*.*\\*/", "xyz /* hallo */ abc */ 123"},  // greedy
    std::array{"/\\*.*?\\*/", "xyz /* hallo */ abc */ 123"}  // nicht greedy
  };
  for (auto testfall : testfaelle) {
    RegexTester rt(testfall[0], testfall[1]);
    rt.run();
    std::cout << '\n';
  }
}

int main(int argc, char* argv[])
{
  if (3 != argc) {
    testfaelle();
    std::cout << "Gebrauch: testRegex.exe \"regex\" \"teststring\"\n"
                 "ansonsten werden eingebaute Testfälle ausgegeben.\n";
  }
  else {
    try {
      RegexTester rt(argv[1], argv[2]);
      rt.run();
    }
    catch (std::regex_error& re) {
      std::cerr << "Fehler: " << re.what() << '\n';
    }
  }
}
