#ifndef WORKER_H
#define WORKER_H
#include <chrono>
#include <condition_variable>
#include <iostream>
#include <mutex>
#include <thread>

class Worker {
public:
  void operator()()
  {
    while (!istBeendet()) {
      if (istPausierend()) {
        std::cout << "Worker pausiert!" << std::endl;
        std::unique_lock<std::mutex> lock(mtxPause);
        cond.wait(lock);                     // warten
      }
      else {                                 // arbeiten
        std::cout << "Worker arbeitet!" << std::endl;
        std::this_thread::sleep_for(std::chrono::milliseconds(300));
      }
    }
    std::cout << "Worker macht Feierabend!" << std::endl;
  }

  void pausieren()
  {
    std::scoped_lock<std::mutex> lock(mtxPause);
    pause = true;
  }

  [[nodiscard]] bool istPausierend()
  {
    std::scoped_lock<std::mutex> lock(mtxPause);
    return pause;
  }

  void weitermachen()
  {
    std::scoped_lock<std::mutex> lock(mtxPause);
    pause = false;
    std::cout << "Worker macht weiter!" << std::endl;
    cond.notify_one();
  }
  void feierabend()
  {
    std::scoped_lock<std::mutex> lock(mtxEnde);
    beendet = true;
    cond.notify_one();                            // ... falls im Zustand pausierend
  }

  [[nodiscard]] bool istBeendet()
  { 
    std::scoped_lock<std::mutex> lock(mtxEnde);
    return beendet; 
  }

private:
  bool pause{false};
  bool beendet{false};
  std::mutex mtxEnde;
  std::mutex mtxPause;
  std::condition_variable cond;
};
#endif
