#include "ThreadGroup.h"
#include <atomic>
#include <iostream>
namespace {
int nonAtomicCounter{0};
int atomicCounter{0};
std::atomic_ref<int> atomicref(atomicCounter);
}

void testeAtomizitaet()
{
  for (int i = 0; i < 10000; ++i) {
    ++nonAtomicCounter;
    //++atomicref;  // oder:
    atomicref.fetch_add(1);
  }
}

int main()
{
  ThreadGroup threadgroup;
  for (int i = 0; i < 100; ++i) {
    threadgroup.add_thread(testeAtomizitaet);
  }
  // Beendigung der Threads abwarten:
  threadgroup.join_all();                    // kann hier nicht entfallen
  std::cout << "nicht-atomarer Zähler = " << nonAtomicCounter << '\n';
  std::cout << "atomarer Zähler       = " << atomicCounter << '\n';
}
