#include <future>
#include <iostream>
#include <thread>
#include <utility>

[[nodiscard]] int summe(int n) 
{
  int ergebnis {0};
  for (int i = 1; i <= n; ++i) {
    ergebnis += i;
  }
  // lange Berechnungszeit simulieren
  std::this_thread::sleep_for(std::chrono::seconds(2));
  return ergebnis;
}

int main() 
{
  std::packaged_task<int(int)> task(summe);
  std::future<int> result = task.get_future();
  std::jthread task_thread(std::move(task), 10);
  std::cout << "Auf Ende der Berechnung warten..." << std::endl;
  std::cout << "Ergebnis: " << result.get() << '\n';
}
