#include "tree.h"
#include <QDir>
#include <QFileInfo>
#include <QFileInfoList>
#include <iostream>
#include <stdexcept>

namespace {
void tree(const QDir& d, int level)
{
  QStringList eintraege = d.entryList(QDir::Dirs | QDir::Files
                             | QDir::NoDotAndDotDot);
  for(const auto& filename : eintraege) {
    QString absPfad(d.absolutePath() + "/" + filename);
    for (int i = 0; i < level; ++i) {
      std::cout << " |  ";
    }
    std::cout << " |-- " << filename.toStdString() << '\n';
    QFileInfo qi(absPfad);
    if (qi.isDir()) {
      QDir dir(absPfad);
      tree(dir, level + 1);
    }
  }
}
}                                            // Ende anonymer Namespace

void tree(const std::string& verz)
{
  QFileInfo pfad(verz.c_str());
  if (pfad.isDir()) {
    std::cout << verz << '\n';
    QDir dir(verz.c_str());
    tree(dir, 0);
  }
  else {
    throw std::runtime_error(" ist kein Verzeichnis!");
  }
}
