#ifndef WINDOW_H
#define WINDOW_H
#include "QtBeispiel.h"
#include <QApplication>
#include <QtGui>
#include <QtWidgets/QGridLayout>
#include <QtWidgets/QLabel>
#include <QtWidgets/QMainWindow>
#include <QtWidgets/QMenuBar>
#include <QtWidgets/QStatusBar>

class Window : public QMainWindow {
  // Das Makro  Q_OBJECT sorgt u.a. für die richtige Interpretation der Signale und Slots.
  Q_OBJECT

public:
  Window()
    : widget{new QtBeispiel(this)}, statusLabel{
                                          new QLabel("nicht bewegt", this)}
  {
    setGeometry(100, 100, 400, 300);
    setCentralWidget(widget);
    statusBar()->addWidget(statusLabel);
    menuAnlegen(); // siehe unten
    connect(widget->getZeichenflaeche(), &Zeichenflaeche::radiusChanged, this,
            &Window::statuszeileAktualisieren);
  }

private slots:
  void statuszeileAktualisieren(int radius)
  {
    if (radius < widget->maxradius() / 2) {
      statusLabel->setText("<span style=\"color:green\">klein</span>");
    }
    else {
      statusLabel->setText("<span style=\"color:red\">gross</span>");
    }
  }

private:
  void menuAnlegen()
  {
    auto fileMenu = menuBar()->addMenu(tr("&Datei"));
    QAction* quitAction = new QAction(tr("&Ende"), this);
    quitAction->setShortcut(tr("Ctrl+Q"));
    fileMenu->addAction(quitAction);
    // qApp ist globale Variable der Applikation, siehe \#include <QApplication>
    connect(quitAction, &QAction::triggered, qApp, &QApplication::quit);
  }

  QtBeispiel* widget;
  QLabel* statusLabel;
};
#endif

