#include <boost/asio.hpp>
#include <ctime>
#include <iostream>
#include <string>
#include <string_view>
using boost::asio::ip::tcp;
using namespace std;

[[nodiscard]] string getZeitstring(string_view format)
{
  constexpr int maximum{80};
  string buf(maximum, '\0');
  time_t jetzt = time(nullptr);
  if (format[1] == 's') {     // Sonderbehandlung für \%s, das nicht jeder Compiler kennt
    auto pos{maximum};
    while (jetzt > 0) {                      // Zahl > 0  umwandeln
      buf[--pos] = jetzt % 10 + '0';
      jetzt /= 10;
    }
    return buf.substr(pos);
  }
  else {                           // Umwandlung je nach Format-String mit strftime()
    tm* z = localtime(&jetzt);
    strftime(buf.data(), maximum, format.data(), z);
    return buf;
  }
}

int main(int argc, char* argv[])
{
  if (argc != 2) {
    cout << "Gebrauch: " << argv[0] << " <port>\n";
    return 1;
  }
  boost::asio::io_service ioService;
  unsigned short port = atoi(argv[1]);
  tcp::acceptor acceptor(ioService, tcp::endpoint(tcp::v4(), port));
  while (true) {                             // Abbruch mit Strg+C
    tcp::socket socket(ioService);
    cout << "lauschen  an Port " << port << " ... (Abbruch mit Strg+C)\n";
    acceptor.accept(socket);
    char wahl {0};
    // 1 Byte lesen
    socket.read_some(boost::asio::buffer(&wahl, 1));
    string_view format = "%c";
    switch (wahl) {
    case '1': format = "%c";                     break;
    case '2': format = "%A, %d. %B %Y, %X Uhr";  break;
    case '3': format = "%X";                     break;
    case '4': format = "%s";                     break;
    }
    auto zeitstring = getZeitstring(format);
    socket.write_some(boost::asio::buffer(zeitstring.data(),
                      zeitstring.length() + 1));
  }
}

