#include <boost/asio.hpp>
#include <ctime>
#include <iostream>
using boost::asio::ip::udp;

int main()
{
  boost::asio::io_service ioService;
  udp::socket socket(ioService);
  uint32_t buf[12]{0};                       // muss 32 Bits haben
  constexpr auto puffergroesse = sizeof(buf);
  buf[0] = htonl((3 << 27) | (3 << 24));     //siehe RFC 5905 [NTP]
  udp::resolver resolver(ioService);
  udp::endpoint zeitserver{*resolver.resolve("europe.pool.ntp.org", "123")};
  socket.open(boost::asio::ip::udp::v4());
  socket.send_to(boost::asio::buffer(buf, puffergroesse), zeitserver);
  udp::endpoint hier;
  socket.receive_from(boost::asio::buffer(buf, puffergroesse), hier);
  time_t secs = ntohl(buf[8]) - 2208988800u;
  auto z{localtime(&secs)};
  auto secfrac = static_cast<double>(ntohl(buf[9])) / 4294967296.0;
  std::cout << z->tm_mday << '.' << z->tm_mon + 1 << '.' 
            << z->tm_year + 1900 << "   " 
            << z->tm_hour << ':' << z->tm_min << ':' 
            << secfrac + z->tm_sec << '\n';
}
