CXX := g++
CXXFLAGS := -Wall -c 
OBJDIR := obj
BINDIR := bin
DISTDIR := dist
EXEFILE := projekt.exe
ifdef ComSpec  # Windows mkdir kann nicht -p
MKDIR=mkdirp
else
MKDIR=mkdir
endif
objects := $(subst $(SRCDIR),$(OBJDIR),$(cppfiles:.cpp=.o))

.PHONY: all clean dist

all: $(BINDIR)/$(EXEFILE)

$(OBJDIR)/%.o: $(SRCDIR)/%.cpp 
	$(MKDIR) -p $(@D)
	$(CXX) $(CXXFLAGS) $< -o $@

$(BINDIR)/$(EXEFILE): $(objects)
	$(MKDIR) -p $(BINDIR)
	$(CXX) -o $@ $^

$(DISTDIR)/gepackt.7z: $(BINDIR)/$(EXEFILE)
	$(MKDIR) -p $(DISTDIR)
	7z a $(DISTDIR)/gepackt.7z $(BINDIR)/$(EXEFILE)

dist: $(DISTDIR)/gepackt.7z

clean:
	rm -rf $(OBJDIR) $(BINDIR)

distclean: clean
	rm -rf $(DISTDIR)



