#include <iostream>

[[nodiscard]] int summe(int a, int b) { return a + b; }
// Alternativ mit Erklärung
[[nodiscard("Produkt ignoriert!")]]  int produkt(int a, int b) { return a * b; }

struct [[nodiscard]] S {
  int wert = 42;
};
S getStruct() { S s; return s; }

enum class [[nodiscard]] Farbe{rot, gelb, gruen};
Farbe getRot() { return Farbe::rot; }

int main()
{
  // Kein Problem: Hier werden alle Rückgabewerte verwendet.
  std::cout << summe(3, 4) << ' ' << produkt(3, 4) << '\n';
  std::cout << getStruct().wert << '\n';
  if (getRot() == Farbe::rot) {
    std::cout << "Die Farbe ist rot\n";
  }
  // Ohne Verwendung des Rückgabewerts sind die folgenden  Aufrufe sinnlos.
  // Sie führen zu Warnungen des Compilers.
  summe(3, 4);
  produkt(3, 4);
  getRot();
  getStruct();
}
