#include <algorithm>
#include <numeric>
#include <showContainer.h>
#include <utility>                                                     // pair
#include <vector>

struct Absolutbetrag {          // Funktor, gekennzeichnet durch operator()()
  [[nodiscard]] bool operator()(int x, int y) const 
  { 
    return std::abs(x) < std::abs(y); 
  }
};

[[nodiscard]] bool abskleiner(int x, int y) { return std::abs(x) < std::abs(y);}

using namespace std;

int main()
{
  vector<long> v(10);
  iota(v.begin(), v.end(), -5);                                        // -5 ... +4
  showContainer(v);
  cout << "Minimum: " << *min_element(v.begin(), v.end()) << '\n';     // -5
  cout << "Maximum: " << *max_element(v.begin(), v.end()) << '\n';     // 4
  cout << "Minimum des Absolutbetrags mit Funktor: "
       << *min_element(v.begin(), v.end(), Absolutbetrag()) << '\n';   // 0
  cout << "Minimum des Absolutbetrags mit Funktion: "
       << *min_element(v.begin(), v.end(), abskleiner) << '\n';        // 0
  cout << "Minimum des Absolutbetrags mit Lambda-Funktion: "
       << *min_element(v.begin(), v.end(), 
                       [](auto a, auto b) { return abs(a) < abs(b); }) // 0
       << '\n';  
  cout << "Minimum und Maximum mit nur einem Funktionsaufruf: ";
  auto iteratorPair = minmax_element(v.begin(), v.end());
  cout << *iteratorPair.first << "  " << *iteratorPair.second << '\n';
  // Mehr über pair lesen Sie in Abschnitt 26.2.
}

