#include <Random.h>
#include <algorithm>
#include <deque>
#include <showContainer.h>
using namespace std;

int main()
{
  deque<int> d;
  Random zufall(100);
  for (unsigned int i = 0; i < 15; ++i) {
    d.push_front(zufall());
  }
  showContainer(d);
  auto nth = d.begin();
  ranges::nth_element(d, nth);
  cout << "Kleinstes Element: " << (*nth) << '\n';
  // Das Standardvergleichsobjekt greater dreht die Reihenfolge um.
  // In diesem Fall steht das größte Objekt an der ersten Position.
  // Hier ist immer noch nth == d.begin().
  ranges::nth_element(d, nth, greater<>());
  cout << "Größtes Element : " << (*nth) << '\n';
  // Mit dem < -Operator steht das größte Element am Ende:
  nth = d.end();
  --nth;                                     // zeigt nun auf das letzte Element
  ranges::nth_element(d, nth);
  cout << "Größtes Element : " << (*nth) << '\n';
  // Median
  nth = d.begin() + ssize(d) / 2;
  ranges::nth_element(d, nth);
  cout << "Medianwert      : " << (*nth) << '\n';
}

