#include <regex>
#include <string>
#include <string_view>
#include <vector>
#include <showContainer.h>                   // siehe Seite 524

// String splitten mit regulärem Ausdruck. Rückgabe: Vektor mit Substrings
[[nodiscard]] auto regexsplit(std::string_view s, std::string_view muster)
{
  std::regex reg(muster.data());
  auto anfang = std::regex_iterator(s.begin(), s.end(), reg);
  std::vector<std::string> ergebnis;
  decltype(anfang) ende;  // = regex_iterator<std::string_view::const_iterator>
  for(auto i = anfang; i  != ende; ++i) {
    ergebnis.emplace_back(i->str());       // string-Kopie ablegen
  }
  return ergebnis;
}

int main()
{
  std::string_view text("The quick brown, fox jumps.over the lazy dog's back.");
  // Trenner : Punkt, Komma, Leerzeichen
  showContainer(regexsplit(text, "[^\\.^,^ ]+"), "", "*\n");
}

