#include <iostream>
#include <limits>
#include <string>
#define PRINT(X) std::cout << (#X) << " = " << (X) << '\n';

namespace {
[[nodiscard]] std::string i2string(int i)
{
  std::string ergebnis;
  if (i == 0) {
    ergebnis = "0";
  }
  else {
    bool negativ = (i < 0);
    while (i != 0) {
      ergebnis.insert(ergebnis.begin(), abs(i % 10) + '0');
      i /= 10;
    }
    if (negativ) {
      ergebnis.insert(ergebnis.begin(), '-');
    }
  }
  return ergebnis;
}
}          // namespace

int main()
{
  PRINT(i2string(1 << 31))
  PRINT(i2string(std::numeric_limits<int>::min()))
  PRINT(i2string(-33))
  PRINT(i2string(-1))
  PRINT(i2string(-0))
  PRINT(i2string(0))
  PRINT(i2string(1))
  PRINT(i2string(33))
  PRINT(i2string(unsigned(-1) >> 1))
  PRINT(i2string(std::numeric_limits<int>::max()))
}
