#include <splitAsVector.h>             // siehe Seite 714
#include <Datum.h>  
#include <algorithm>
#include <iostream>
#include <regex>

[[nodiscard]] bool datumok(const std::string& eingabe)
{
  std::regex datumregex("\\d\\d?\\.\\d\\d?\\.\\d\\d\\d\\d");
  bool ergebnis = std::regex_match(eingabe, datumregex);
  if (ergebnis) {          // Syntax ok, Inhalt prüfen
    auto v = splitAsVector(eingabe, ".");
    Datum(std::stoi(v[0]), std::stoi(v[1]), std::stoi(v[2]));  // Exception bei Fehler
  }
  return ergebnis;
}

using namespace std;

int main(int argc, char* argv[])
{
  if (2 != argc) {
    cout << "Gebrauch: " << argv[0] << " \"Datumstring, z.B. tt.mm.jjjj\"\n";
  }
  else {
    try {
      if (datumok(argv[1])) {
        cout << argv[1] << " ist ein gültiges Datum.\n";
      }
      else {
        cout << argv[1] << " ist kein gültiges Datum. Falsche Syntax\n";
      }
    }
    catch (const UngueltigesDatumException& ude) {
          cerr << "Syntax ok, Inhalt falsch: " << ude.what() << '\n';
    }
  }
}

