#include <algorithm>                         // remove
#include <iostream>
#include <numeric>                           // iota
#include <showContainer.h>
#include <string_view>
#include <vector>
using namespace std;

int main()
{
  vector<char> v(26);
  iota(v.begin(), v.end(), 'a');             // Alphabet mit Kleinbuchstaben erzeugen
  showContainer(v, "\n");
  cout << "remove 't': ";
  auto last = remove(v.begin(), v.end(), 't');
  // last = neues Ende nach der Verschiebung, v.end() bleibt unverändert!
  // Nur die Zeichen von begin() bis last sind von Bedeutung.
  showContainer(v.begin(), last);            // Anzeige nur bis last
  // Vokale entfernen:
  last = remove_if(v.begin(), last, 
               [](char c) {  return string_view {"aeiouyAEIOUY"}.find(c) 
                                   != std::string_view::npos;});
  cout << "nur noch Konsonanten übrig: ";
  showContainer(v.begin(), last);             // bcdfghjklmnpqrsvwxz
  cout << "\nVollständige Sequenz einschließlich bedeutungsloser "
          "Elemente am Ende:\n";
  showContainer(v, "\n");
}

