#include <algorithm>
#include <cctype>
#include <showContainer.h>
#include <string>
#include <vector>

[[nodiscard]] std::string upper_case(std::string s)   // unäre Operation als Funktion
{
  std::ranges::transform(s, s.begin(), toupper);
  return s;
}

struct Verketten {                                    //  binäre Operation als Funktor
  [[nodiscard]] std::string operator()(const std::string& a, 
                                       const std::string& b) const
  {
    return a + " und " + b;
  }
};
using namespace std;

int main()
{
  vector<string> maedels{"Annabelle", "Scheherazade", "Julia"};
  vector<string> jungs{"Nikolaus", "Amadeus", "Romeo"};
  if (maedels.size() != jungs.size()) {
    cout << "Paarbildung nicht möglich!\n";
  }
  else {
    vector<string> paare(maedels.size());
    ranges::transform(jungs,
                      jungs.begin(),         // Ziel == Quelle
                      upper_case);           // in Großbuchstaben wandeln
    ranges::transform(maedels, jungs, paare.begin(), Verketten());
    showContainer(paare, "", "\n");          // gebildete Paare ausgeben
  }
}
