#include <array>
#include <iostream>
using namespace std;

int main()
{
  constexpr int anzahl{3};
  constexpr array<int, anzahl> tabelle {9, -10};  // Initialisierung,
                                                  // letztes Element ist 0
  // Benutzung mit Iterator
  for (array<int, anzahl>::const_iterator i = tabelle.begin();
                                          i != tabelle.end(); ++i) {
    cout << *i << ' ';
  }
  cout << '\n';
  // Benutzung mit Iterator und auto
  for (auto i = tabelle.begin(); i != tabelle.end(); ++i) {
    cout << *i << ' ';
  }
  cout << '\n';
  // Benutzung wie Vektor
  for (auto i {0z}; i < ssize(tabelle); ++i) {
    cout << tabelle[i] << ' ';
  }
  cout << '\n';
  // Benutzung wie allg. Container
  for (auto el : tabelle) {
    cout << el << ' ';
  }
  cout << '\n';
  // Benutzung wie Tupel
  cout << get<0>(tabelle) << ' ' 
       << get<1>(tabelle) << ' ' 
       << get<2>(tabelle) << '\n';
  // Erzeugung aus C-Array
  auto tabelle2 { to_array({1, 2, 3}) };
  for (auto el : tabelle2) {
    cout << el << ' ';
  }
  cout << '\n';
}
