#include <array>
#include <iostream>

// template <typename Feldtyp>
// void tabellenausgabe_stdarray(Feldtyp tabelle) {  // geht auch,
// erzwingt aber keinen
// std::array-Parameter. Dann wäre z.B. auch vector möglich
template <typename T, std::size_t Z>
void tabellenausgabe_stdarray(const std::array<T, Z>& tabelle)
{
  for (auto wert : tabelle) {
    std::cout << wert << ' ';
  }
  std::cout << '\n';
  // alternativ
  for (auto i {0z}; i < ssize(tabelle); ++i) {
    std::cout << tabelle[i] << ' ';
  }
  std::cout << '\n';
}

int main()
{
  constexpr std::array feld{1, 2, 3, 4, 5, 6};
  tabellenausgabe_stdarray(feld);
}
