#include <algorithm>
#include <iostream>
#include <map>
#include <string_view>
using namespace std;

void druckeMap(const map<int, string_view>& m)
{
  for (const auto& el : m) {
    cout << "  (" << el.first << ", " << el.second << ')'; 
  }
  cout << '\n';
}

int main()
{
  map<int, string_view> personen {{101, "Meyer"}, {2022, "Müller"}, 
                                  {8001, "Schulz"}};
  druckeMap(personen);
  auto nh = personen.extract(2022);          // Nodehandle extrahieren
  druckeMap(personen);
  nh.key() = 2023;                           // Schlüssel ändern
  personen.insert(std::move(nh));                 // Nodehandle einfügen
  druckeMap(personen);
}
