#include <iostream>
#include <span>

void containerausgeben(std::span<const int> spanne)
{
  for (auto wert : spanne) { std::cout << wert << ' '; }
  std::cout << ": erster Wert = " << spanne.front() 
            << "  letzter Wert = " << spanne.back() << '\n';
}

int main()
{
  int carray[]{0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
  containerausgeben(carray);
  std::span<const int> spanne {carray};
  containerausgeben(spanne.first(3));        // die ersten drei
  containerausgeben(spanne.last(3));         // die letzten drei
  containerausgeben(spanne.subspan(3, 4));   // die vier ab Position drei
  std::cout << spanne.size() << " Elemente = "
            << spanne.size_bytes() << " Bytes\n";
  std::span<const int> spanne2 {carray, 5};  // nur fünf Elemente
  containerausgeben(spanne2);   
  std::span<const int, 10> spanne3(carray);  // Extent angeben
  std::cout << std::span<const int, 10>::extent << '\n'; // objektunabhängig
}
