#include <iostream>
#include <list>
#include <iterator>
#include <vector>

template <class Container>                   // passt für Vektor und Liste 
[[nodiscard]] auto mittleresElement(const Container& cont)
{
  auto iter {cont.begin()};
  auto anzahl {0u};
  while(anzahl++ <  cont.size()/2) {  // Alternative advance(), siehe Text
    ++iter;
  }
  return *iter;
}

// passt für Vektor, aber nicht für Liste 
[[nodiscard]] auto mittleresElement(
                            const std::random_access_iterator auto& cont)
{
  return cont[cont.size()/2];
}

int main()                                   // Hauptprogramm
{
  std::list<int> liste{0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
  std::vector<int> vec{0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
  // Aufruf der ersten Implementierung für die Liste
  std::cout << mittleresElement(liste) << '\n';
  // Aufruf der zweiten Implementierung für den Vektor
  std::cout << mittleresElement(vec) << '\n';
}

