#ifndef KREIS_H
#define KREIS_H
#include <iostream>
#include <numbers>                             // Zahl pi

class Kreis {
public:
  explicit constexpr Kreis(double r) 
  : radius(r)
  {
    if (r < 0) {
      std::cerr << "Fehler: negativer Radius r in Kreis(r)\n";
      exit(1);
    }
  }

  [[nodiscard]] constexpr auto getRadius() const { return radius; }

  [[nodiscard]] constexpr auto getFlaeche() const 
  { 
    return radius * radius * std::numbers::pi; 
  }

  constexpr void setRadius(double r)
  { 
    if (r < 0) {
      std::cerr << "Fehler: negativer Radius r in setRadius(r)\n";
      exit(1);
    }
    radius = r;
  }
private:
  double radius;
};

// freie Funktion
[[nodiscard]] inline constexpr Kreis skalieren(Kreis kreis, double faktor) 
{
  kreis.setRadius(kreis.getRadius() * faktor);
  return kreis;
}
#endif

