#ifndef ORTMITKOPIERKONSTRUKTOR_H
#define ORTMITKOPIERKONSTRUKTOR_H
#include <cmath>          // wegen sqrt()
#include <iostream>

class Ort {
public:
  Ort(int einX = 0, int einY = 0) : xKoordinate(einX), yKoordinate(einY) {}

  Ort(const Ort& orig)          // Kopierkonstruktor zur Dokumentation
      : xKoordinate(orig.xKoordinate), yKoordinate(orig.yKoordinate)
  {
    std::cout << "Kopierkonstruktor für (" << xKoordinate << ", " << yKoordinate
              << ") aufgerufen\n";
  }

  [[nodiscard]] int getX() const { return xKoordinate; }
  [[nodiscard]] int getY() const { return yKoordinate; }
  void aendern(int x, int y)
  {
    xKoordinate = x;
    yKoordinate = y;
  }

private:
  int xKoordinate;
  int yKoordinate;
};

// globale Funktionen

// Berechnung der Entfernung zwischen zwei Orten
[[nodiscard]] inline double entfernung(const Ort& ort1, const Ort& ort2)
{
  auto dx = static_cast<double>(ort1.getX() - ort2.getX());
  auto dy = static_cast<double>(ort1.getY() - ort2.getY());
  return std::sqrt(dx * dx + dy * dy);
}

// Anzeige auf der Standardausgabe
inline void anzeigen(const Ort& O) { std::cout << '(' << O.getX() << ", " << O.getY() << ')'; }
#endif

