#ifndef ORT_H
#define ORT_H
#include <cmath>          // wegen sqrt()
//#include <cstdlib>
#include <iostream>

class Ort {
public:
  // Typumwandlungskonstruktor
  explicit Ort(std::istream &istr) {
    istr >> xKoordinate >> yKoordinate;
    if (!istr) {
      std::cerr << "Ort-Konstruktor: falsches Eingabeformat. Abbruch!\n";
      exit(1);
    }
  }
  constexpr Ort(int einX = 0, int einY = 0)
      : xKoordinate{einX}, yKoordinate{einY} {}

  [[nodiscard]] constexpr auto getX() const { return xKoordinate; }
  [[nodiscard]] constexpr auto getY() const { return yKoordinate; }

  constexpr void aendern(int x, int y) {
    xKoordinate = x;
    yKoordinate = y;
  }

private:
  int xKoordinate = 0;
  int yKoordinate = 0;
};

// freie Funktionen

// Berechnung der Entfernung zwischen zwei Orten
[[nodiscard]] inline auto entfernung(Ort ort1, Ort ort2) {
  auto dx = static_cast<double>(ort1.getX() - ort2.getX());
  auto dy = static_cast<double>(ort1.getY() - ort2.getY());
  return std::sqrt(dx * dx + dy * dy);
}

// Anzeige auf der Standardausgabe
inline void anzeigen(Ort O) {
  std::cout << '(' << O.getX() << ", " << O.getY() << ')';
}
#endif

