#include <iostream>
#include <locale>
#include <string_view>

int main()
{
  // Funktioniert nicht unter Windows.
  // MinGW für Windows hat keine locale außer C und "" implementiert.
  std::locale loc("de_DE.utf8");
  std::cout.imbue(loc);
  auto& facet = std::use_facet<std::messages<char>>(loc);
  std::string_view software{"grep"};         // Katalog für das Programm grep
  auto cat = facet.open(software.data(), loc);
  if (cat < 0) {
    std::cout << "Deutscher " << software
              << "-Message-Katalog kann nicht geöffnet werden\n";
  }
  else {
    std::cout << "invalid character class -> " 
              << facet.get(cat, 0, 0, "invalid character class") << '\n'
              << "no syntax specified     -> " 
              << facet.get(cat, 0, 0, "no syntax specified") << '\n'
              << "unbalanced (            -> " 
              << facet.get(cat, 0, 0, "unbalanced (") << '\n'
              << "write error             -> " 
              << facet.get(cat, 0, 0, "write error") << '\n';
  }
  facet.close(cat);
}

