#include <fstream>
#include <iostream>
using namespace std;

int main()
{
  constexpr int zeilen{10};
  constexpr int spalten{8};
  double matrix[zeilen][spalten];
  for (int i = 0; i < zeilen; ++i)          // Matrix mit (beliebigen) Werten füllen
    for (int j = 0; j < spalten; ++j)
      matrix[i][j] = i + 1 + (j + 1) / 1000.0;

  // Schreiben als ASCII-Datei (lesbar mit Editor)
  ofstream ziel("matrix.asc");
  if (!ziel) {
    cerr << "Datei kann nicht geöffnet werden!\n";
    return -1;                              // Fehler
  }
  // formatiertes Schreiben
  for (int i = 0; i < zeilen; ++i) {
    for (int j = 0; j < spalten; ++j) {
      ziel.width(8);                        // Breite 8 Zeichen
      ziel << matrix[i][j];
    }
    ziel << '\n';
  }
  ziel.close();            // Datei schließen, damit ziel wiederverwendet werden kann:

  // Schreiben als binäre Datei
  ziel.open("matrix.bin", ios::binary);
  if (!ziel) {
    cerr << "Datei kann nicht geöffnet werden!\n";
    exit(-1);
  }
  ziel.write(reinterpret_cast<const char*>(matrix), sizeof(matrix));
}                                           // automatisches close()

