#ifndef SIMPLESTACK1_H
#define SIMPLESTACK1_H
#include <array>
#include <cassert>

template <typename T>
class SimpleStack1 {
public:
  static const int maxSize {20};             // siehe Text
  // inline definierte Methoden
  [[nodiscard]] bool empty() const { return anzahl == 0; }
  [[nodiscard]] bool full() const  { return anzahl == maxSize; }
  [[nodiscard]] auto size() const  { return anzahl; }
  void clear()       { anzahl = 0; }         // Stack leeren
  // Methoden, deren Implementation unten folgt:
  const T& top() const;                      // letztes Element sehen
  void pop();                                // Element entfernen
  // Vorbedingung für top und pop: Stack ist nicht leer
  void push(const T& x);                     // x auf den Stack legen
  // Vorbedingung für push: Stack ist nicht voll
private:
  int anzahl{0};                             // Anfangswert
  std::array<T, maxSize> arr{};              // Behälter für Elemente
};
// noch fehlende Methoden-Implementierungen als Alternative zur inline-Definition
template <typename T>
const T& SimpleStack1<T>::top() const
{
  assert(!empty());
  return arr.at(anzahl - 1);
}

template <typename T>
void SimpleStack1<T>::pop()
{
  assert(!empty());
  --anzahl;
}

template <typename T>
void SimpleStack1<T>::push(const T& x)
{
  assert(!full());
  arr.at(anzahl++) = x;
}
#endif
