#ifndef STRINGANSICHT_H
#define STRINGANSICHT_H
#include <cassert>
#include <cstddef>
#include <iostream>                         // ostream
#include <string>
using IndexType = std::ptrdiff_t;

class StringAnsicht {
public:
  explicit constexpr StringAnsicht(const char* cstr = "") 
    : zeiger(cstr), laenge(static_cast<IndexType>
       (std::char_traits<char>::length(cstr)))
    { }
    
  explicit StringAnsicht(const std::string& str) 
    : zeiger(str.data()), laenge(std::ssize(str))
    { }
  [[nodiscard]] constexpr auto at(int position) const
  {
    assert(position < laenge);
    return zeiger[position];
  }
  [[nodiscard]] constexpr auto length() const { return laenge; }
  [[nodiscard]] constexpr auto data()   const { return zeiger; }
  [[nodiscard]] constexpr auto begin()  const { return zeiger; }
  [[nodiscard]] constexpr auto end()    const { return zeiger + laenge; }
private:
  const char* zeiger;
  IndexType laenge;
};

inline void anzeigen(std::ostream& os, StringAnsicht m) { os << m.data(); }
#endif

