#include <iostream>

class Basis {
public:
  Basis() = default;
  virtual ~Basis() = default;
  Basis(const Basis&) = delete;
  Basis& operator=(const Basis&) = delete;
};

class Abgeleitet : public Basis {
public:
  void f() { std::cout << "Ausführung von f()\n"; }
};

void g(Basis* pB) // g() benutzt f()
{
  auto* pA = dynamic_cast<Abgeleitet*>(pB);
  if (pA) {  // Null-Zeiger bei Scheitern des dynamic_cast
    pA->f(); // Abgeleitet::f()
  }
}

int main()
{
  Basis einB;
  Abgeleitet einA;
  Basis* pBB = &einB;
  Basis* pBA = &einA;
  // Durch den folgenden Aufruf von g() wird in  g() Abgeleitet::f() ausgeführt, 
  // weil pBA auf ein Abgeleitet-Objekt zeigt. pErgebnis zeigt auf einA:
  g(pBA);
  // Abgeleitet::f() wird unten  nicht ausgeführt, weil pB in g() auf ein Basis-Objekt
  //  zeigt. pErgebnis ist undefiniert(!), weil der static_cast ungeeignet ist:
  // Der dynamische Typ des per Zeiger übergebenen Objekts ist nicht vom Typ Abgeleitet.
  g(pBB);
}

