#ifndef RECHTECK_H
#define RECHTECK_H
#include "../../abstrakt/GraphObj.h"

class Rechteck : virtual public GraphObj { // von GraphObj erben
public:
  Rechteck(Ort ort, int h, int b) : GraphObj(ort), dieHoehe{h}, dieBreite{b} {}

  [[nodiscard]] auto hoehe() const { return dieHoehe; }
  [[nodiscard]] auto breite() const { return dieBreite; }

  // Definition der rein virtuellen Methoden
  [[nodiscard]] double flaeche() const override
  {
    return double(dieHoehe) * dieBreite;
  }

  void zeichnen() const override
  {
    GraphObj::zeichnen();
    std::cout << "Rechteck (h x b = " << dieHoehe << " x " << dieBreite
              << ") an der Stelle ";
    anzeigen(bezugspunkt());
    std::cout << '\n';
  }

private:
  int dieHoehe, dieBreite;
};
#endif // RECHTECK_H

