#ifndef WARTESCHLANGED_H
#define WARTESCHLANGED_H
#include <list>

template <typename T>
class Warteschlange {          // mit Delegation an ein list-Objekt  (Attribut liste)
public:
  [[nodiscard]] bool empty() const { return liste.empty(); }
  [[nodiscard]] auto size() const { return liste.size(); }
  void push(const T& x) { liste.push_back(x); }          // am Ende einfügen
  void pop() { liste.pop_front(); }                      // am Anfang entnehmen
  [[nodiscard]] const T& front() const { return liste.front(); } // am Anfang lesen
  [[nodiscard]] const T& back()  const { return liste.back(); }  // am Ende lesen
private:
  std::list<T> liste;
};
#endif

