#ifndef RECHTECK_H
#define RECHTECK_H
#include "GraphObj.h"

class Rechteck : public GraphObj {          // von GraphObj erben
public:
  Rechteck(const Ort& ort, int h, int b) : GraphObj{ort}, dieHoehe{h}, dieBreite{b} {}

  // wird von Quadrat benötigt
  [[nodiscard]] auto hoehe() const { return dieHoehe; }
  [[nodiscard]] auto breite() const { return dieBreite; }

private:
  // Definition der rein virtuellen Methoden
  double flaeche_impl() const override { return static_cast<double>(dieHoehe) * dieBreite; }

  void zeichnen_impl() const override
  {
    GraphObj::zeichnen_impl();
    std::cout << "Rechteck (h x b = " << dieHoehe << " x " << dieBreite << ") an der Stelle ";
    anzeigen(bezugspunkt());
    std::cout << '\n';
  }
  
  // Attribute
  int dieHoehe;
  int dieBreite;
};
#endif          // RECHTECK_H

