#include <cmath>                          // sqrtf()
#include <iostream>
#include <string>                         // to_string()
#include <string_view>
#include <type_traits>
#include <vector>
#include "to_numberOpt.h"

template<class T>
std::optional<T> check_sign(T v)
{
  return v >= 0 ? std::optional<T>{v} : std::nullopt;
}
using namespace std;

template<typename R>
using functiontype = R (*)(double);         // siehe Text

int main()
{
  vector<string_view> tests{"1.0 Rest wird ignoriert",
                            "-1.0", "2.0", "keine Zahl"};
  for (auto sv : tests) {
    cout << '"' << sv << "\" --> ";
    auto result = to_numberOpt<double>(sv)  // Hintereinanderschaltung der Operationen:
     .and_then(check_sign<double>)
     .transform<functiontype<double>>(sqrt)
     .transform<functiontype<string>>(to_string)
     .or_else([] { return optional<string>{"Fehler"}; })
     ;
    if (result) {
      cout << result.value() << '\n';      // Typ ist string&:
      static_assert(is_same_v<string&, decltype(result.value())>);
    }
    else {
      cout << "Nix!\n";      // wird nur erreicht, wenn or_else auskommentiert wird
    }
  }
}

