#ifndef TO_NUMBEREXP_H
#define TO_NUMBEREXP_H
#include <charconv>                       // from_chars()
#include <expected>
#include <string_view>
#include <system_error>                   // errc

template<class T>
std::expected<T, std::errc> to_numberExp(std::string_view sv)
{
  T result{};
  auto [ptr, ec] = std::from_chars(sv.data(), sv.data() + sv.size(), result);
  if (ec == std::errc()) {                // d.h. kein Fehler
    return result;
  }
  return std::unexpected{ec};
}
#endif

