#ifndef TO_NUMBEROPT_H
#define TO_NUMBEROPT_H
#include <charconv>                       // from_chars()
#include <optional>
#include <string_view>
#include <system_error>                   // errc

template<class T>
std::optional<T> to_numberOpt(std::string_view sv)
{
  T result{};
  auto [ptr, ec] = std::from_chars(sv.data(), sv.data() + sv.size(), result);
  if (ec == std::errc()) {                // d.h. kein Fehler
    return result;
  }
  return std::nullopt;
}
#endif

