#ifndef A_H
#define A_H
#include <iostream>
#include <memory>                           // unique_ptr()

class A {
public:
  explicit A(int a_) : a{a_} {}
  virtual ~A() = default;
  A& operator=(const A&) = delete;

  [[nodiscard]] virtual std::unique_ptr<A> clone() const
  {
    std::cout << "virtual A* A::clone()\n";
    return std::unique_ptr<A>(new A(*this));
  }

  virtual void ausgabe() const { std::cout << "A.a = " << a << ' '; }

  [[nodiscard]] virtual bool isEqual(const A& arg) const
  {
    std::cout << "A::isEqual(const A& arg)\n";
    return a == arg.a;
  }

protected:
  A(const A&) = default;

private:
  int a;
};

[[nodiscard]] bool operator==(const A& arg1, const A& arg2)
{
  std::cout << "operator==(const A& arg1, const A& arg2)\n";
  return arg1.isEqual(arg2);
}
#endif

