#ifndef B_H
#define B_H
#include "A.h"

class B : public A {
public:
  B(int a_, int b_)
      : A(a_), // Oberklassenkonstruktor
        b{b_}  // klassenlokale Daten
  {
  }
  B& operator=(const B&) = delete;

  [[nodiscard]] std::unique_ptr<A> clone() const override
  {
    std::cout << "virtual B* B::clone()\n";
    return std::unique_ptr<A>(new B(*this));
  }

  void ausgabe() const override
  {
    A::ausgabe();
    std::cout << "B.b = " << b << ' ';
  }

  [[nodiscard]] bool isEqual(const A& arg) const override
  {
    std::cout << "B::isEqual(const A& arg)\n";
    return A::isEqual(arg) && b == dynamic_cast<const B&>(arg).b;
  }

protected:
  B(const B&) = default;

private:
  int b;
};
#endif
