// main.cpp zeigt die Zuweisung mit clone()
// Diese Datei demonstriert, dass nur systemgenerierte 
// Funktionen bei Zuweisung mit Polymorphie nicht ausreichen.
#include <iostream>
using std::cout;

struct Ober {
  explicit Ober(int i) : iO(i) {}
  Ober(const Ober&) = default;
  Ober& operator=(const Ober&) = default;
  virtual ~Ober() = default;
  int iO;          // Daten der Klasse Ober
};

struct Unter : public Ober {
  Unter(int i, int d) : Ober(i), iU(d) {}
  Unter(const Unter&) = default;
  Unter& operator=(const Unter&) = default;
  int iU;          // Daten der Klasse Unter
};

void vergleicheUnterObjekte(const Ober& o1, const Ober& o2)
{
  auto u1 = dynamic_cast<const Unter&>(o1);
  auto u2 = dynamic_cast<const Unter&>(o2);
  if (u1.iO == u2.iO && u1.iU == u2.iU) {
    cout << "Werte stimmen überein.\n";
  }
  else {
    cout << "Werte stimmen NICHT überein:\nOberklassenwerte:  "
        << u1.iO << ", "<< u2.iO
        << " Unterklassenwerte: "
        << u1.iU << ", " << u2.iU << '\n';
  }
}

int main()
{
  Unter u1(1, 2);
  Unter u2(3, 4);
  cout << "'normale' Zuweisung Unter = Unter: ";
  u1 = u2;          // 'normale' Zuweisung
  vergleicheUnterObjekte(u1, u2);
  Unter u3(5, 6);
  // statischer und dynamischer Typ sind verschieden:
  cout << "polymorphe Zuweisung Ober& = Unter: ";
  Ober& rO2 = u2;          // rO2 ist eine Referenz auf ein Unter-Objekt
  rO2 = u3;                // funktioniert nicht mit dem systemgenerierten
                           // operator=(). Beweis:
  vergleicheUnterObjekte(rO2, u3);
}

