// noch nicht vollständig! (s. Übungsaufgaben)
#ifndef DATUM_H
#define DATUM_H
#include <chrono>
#include <stdexcept>
#include <string>

class UngueltigesDatumException : public std::runtime_error {
public:
//  UngueltigesDatumException(const char* cstr) 
  UngueltigesDatumException(const std::string& str) 
   : std::runtime_error(str)
  { }
};

[[nodiscard]] constexpr bool istSchaltjahr(int jahr)
{
  return std::chrono::year(jahr).is_leap();
}

class [[nodiscard]] Datum {
public:
  Datum() = default; // Standardkonstruktor, aktuelles Datum

  constexpr Datum(int t, int m, int j) // allgemeiner Konstruktor
      : ymd(std::chrono::year(j), std::chrono::month(m), std::chrono::day(t))
  {
    if (!ymd.ok()) {       // Prüfung auf Gültigkeit
       throw UngueltigesDatumException("Ungueltiges Datum!");
    }
  }

  [[nodiscard]] constexpr int tag() const
  {
    return static_cast<unsigned int>(ymd.day());
  }
  [[nodiscard]] constexpr int monat() const
  {
    return static_cast<unsigned int>(ymd.month());
  }
  [[nodiscard]] constexpr int jahr() const
  {
    return static_cast<int>(ymd.year());
  }

  Datum& operator++()                 // Tag hochzählen, Rückgabe per Referenz!
  {
    auto tage = std::chrono::sys_days(ymd);
    ymd = std::chrono::sys_days(tage + std::chrono::days{1});
    return *this;
  }

  Datum operator++(int)               // Tag hochzählen, postfix, Rückgabe per Wert!
  {
    Datum temp{*this};                         // geretteter Zustand
    ++*this;                                   // Präfix ++ aufrufen
    return temp;                               // geretteten Zustand zurückgeben
  }
  
  // alternativ: durch Methode toString() ersetzen (siehe  Übungsaufgabe)
  [[nodiscard]] explicit operator std::string() const //  Typumwandlungsoperator
  {
    return std::to_string(tag()) + "." + std::to_string(monat()) + "." +
           std::to_string(jahr());
  }

private:
  std::chrono::year_month_day ymd{
      std::chrono::floor<std::chrono::days>(std::chrono::system_clock::now())};
};
#endif

