#include <iostream>
#include <limits>
#include <stdexcept>

constexpr auto operator"" _b(const char* bits)
{
  auto ergebnis{0ull};
  auto anzahl{0u};
  while (*bits) {
    if (*bits != '0' && *bits != '1') {
      throw std::runtime_error("unerlaubtes Zeichen im Bitstring");
    }
    // ASCII '0' wird 0 usw.:
    ergebnis = (ergebnis << 1) + static_cast<unsigned long long>(*bits - '0'); 
    ++bits;
    ++anzahl;
    if (anzahl > std::numeric_limits<unsigned long long>::digits) {
      throw std::runtime_error("Bitstring zu lang");
    }
  }
  return ergebnis;
}

int main()
{
  constexpr auto b{1001_b};                 // Suffix \_b
  std::cout << b << '\n';                   // 9 (dezimal)
}

