#ifndef A_H
#define A_H
#include <algorithm>          // swap()
#include <iostream>
#include <typeinfo>

class A {
public:
  A(int a_) : a{a_} {}
  A(const A&) = default;
  virtual ~A() = default;

  [[nodiscard]] virtual A& assign(const A& rhs)
  {
    std::cout << "virtual A& A::assign(const A&)\n";
    if (typeid(*this) != typeid(rhs)) {
      throw std::bad_typeid();
    }
    A temp(rhs);
    swap(temp);
    return *this;
  }

  A& operator=(const A& rhs)
  {
    std::cout << "A& operator=(const A& rhs)\n";
    return assign(rhs);
  }

  virtual void ausgabe() const { std::cout << "A.a = " << a << ' '; }

  void swap(A& rhs) { std::swap(a, rhs.a); }

  [[nodiscard]] virtual bool isEqual(const A& arg) const
  {
    std::cout << "A::isEqual(const A& arg)\n";
    return a == arg.a;
  }

private:
  int a;
};

[[nodiscard]] bool operator==(const A& arg1, const A& arg2)
{
  std::cout << "operator==(const A&, const A&)\n";
  return arg1.isEqual(arg2);
}
#endif
