#include <algorithm>
#include <compare>
#include <iostream>
#include <vector>

class Punkt {
public:
  constexpr Punkt(double x, double y) : x_(x), y_(y) {}
  [[nodiscard]] constexpr double x() const { return x_;}
  [[nodiscard]] constexpr double y() const { return y_;}
  // erzeugt auch ==, !=
  [[nodiscard]] constexpr auto operator<=>(const Punkt&) const = default;
private:
  double x_;
  double y_;
};

int main()
{
  std::vector<Punkt> punkte { {1.2, 2.1}, {1.0, 0.1}, {1.0, 1.0}, 
                              {2.2, 2.2}, {2.0, 0.2}, {2.1, 1.2},
                              {0.2, 2.0}, {0.0, 0.0}, {0.1, 1.0}};
  std::cout.setf(std::ios::fixed);
  std::cout.precision(1);
  for(auto p : punkte) {
    std::cout << '(' << p.x() << ", " << p.y() <<") "; 
  }
  std::cout << '\n';
  std::sort(punkte.begin(), punkte.end());
  for(auto p : punkte) {
    std::cout << '(' << p.x() << ", " << p.y() <<") "; 
  }
  std::cout << '\n';
}
