#include <exception>
#include <iomanip>
#include <iostream>
#include <string>
using namespace std;

int main()
{
  try {
    cout << showbase;                           // Währungsymbol anzeigen
    long money{12345};                          // Betrag in Cent, Typ long
    cout.imbue(locale("de_DE.utf8"));           // siehe Kapitel 30
    cout << put_money(money) << '\n';           // 123,45 euro
    cout << put_money(money, true) << '\n';     // 123,45 EUR
    string money_str{"12345"};                  // Betrag in Cent, Typ string
    cout.imbue(locale("en_US.utf8"));           // siehe Kapitel 30
    cout << put_money(money_str) << '\n';       // \$123.45
    cout << put_money(money_str, true) << '\n'; // USD  123.45
  }
  catch (exception& ex) {
    cerr << ex.what() << "\nlocale wird von diesem System nicht unterstützt\n";
  }
}

