//  Datei hexadezimal ausgeben
// Hilfsmittel: Zeichen mit String ermitteln
#include <cstdlib>          // für exit()
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

int main()
{
  cout << "Dateiname :";
  string quelldateiname{"unbekannt"};
  getline(cin, quelldateiname);

  ifstream quelle(quelldateiname, ios::binary);
  if (!quelle) {          // muss existieren
    cerr << quelldateiname << " kann nicht geöffnet werden!\n";
    exit(-1);
  }

  // char ist notwendig, weil get(unsigned char&) nicht
  // implementiert ist (GNU C++)
  char c{'x'};          // signed!
  int count = 0;
  while (quelle.get(c)) {
    auto uc = static_cast<unsigned char>(c);
    auto zahl = static_cast<unsigned int>(uc);
    const string codierung{"0123456789ABCDEF"};
    // 2 stellig ausgeben
    cout << codierung.at(zahl / 16) << codierung.at(zahl % 16) << ' ';
    if (++count % 20 == 0) {
      cout << '\n';
    }
  }
  cout << '\n';
}
