#ifndef BETRAG_H
#define BETRAG_H
#include <cstdlib>          // für exit()
#include <iostream>

// Das Template setzt voraus, dass die arithmetische Operation
// - (unäres Minus) für den Datentyp T definiert und sinnvoll ist.
// Für den Datentyp complex (für komplexe Zahlen) ist das nicht
// ausreichend.
template <typename T>
[[nodiscard]] T betrag(T t) { return (t < 0) ? -t : t; }

// Template-Spezialisierung
template <>
[[nodiscard]] char betrag(char c)
{
  std::cerr << "Betrag von 'char' ist undefiniert\n";
  exit(1);
  return c;          // damit der Compiler zufrieden ist (wg. exit nicht
                     // erreichbar)
}

// Template-Spezialisierung
template <>
[[nodiscard]] bool betrag(bool b)
{
  std::cerr << "\nBetrag von 'bool' ist undefiniert\n";
  exit(1);
  return b;          // damit der Compiler zufrieden ist (wg. exit nicht
                     // erreichbar)
}
#endif
