#include <cctype>
#include <iostream>

// ********** Funktionsprototypen **********
[[nodiscard]] long zahl(char& c);
[[nodiscard]] long ausdruck(char& c);
[[nodiscard]] long summand(char& c);
[[nodiscard]] long faktor(char& c);

// ********** Hauptprogramm **********
int main()
{
  char ch{'e'};
  do {
    std::cout << "\n>>";
    std::cin.get(ch);
    if (ch != 'e')
      std::cout << ausdruck(ch);
  } while (ch != 'e');
}

// ********** Funktionsdefinitionen **********
long ausdruck(char& c)                  // Übergabe per Referenz!
{
  long a{0L};                          // Hilfsvariable für Ausdruck
  if (c == '-') {
    std::cin.get(c);                    // - im Eingabestrom überspringen
    a = -summand(c);                    // Rest an summand() übergeben
  }
  else {
    if (c == '+')
      std::cin.get(c);                  // + überspringen
    a = summand(c);
  }
  while (c == '+' || c == '-')
    if (c == '+') {
      std::cin.get(c);                  // + überspringen
      a += summand(c);
    }
    else {
      std::cin.get(c);                  // - überspringen
      a -= summand(c);
    }
  return a;
}

long summand(char& c)
{
  long s{faktor(c)};
  while (c == '*' || c == '/')
    if (c == '*') {
      std::cin.get(c);                  // * überspringen
      s *= faktor(c);
    }
    else {
      std::cin.get(c);                  // / überspringen
      s /= faktor(c);
    }
  return s;
}

long faktor(char& c)
{
  long f{0L};
  if (c == '(') {
    std::cin.get(c);                    // ( überspringen
    f = ausdruck(c);
    if (c != ')')
      std::cout << "Rechte Klammer fehlt!\n";          //*** s.u.
    else
      std::cin.get(c);                  // ) überspringen
  }
  else
    f = zahl(c);
  return f;
}

long zahl(char& c)
{
  long z{0L};
  while (isdigit(c)) {
    z = 10L * z + long(c - '0');
    std::cin.get(c);
  }
  return z;
}

