#ifndef RATIONAL_H
#define RATIONAL_H
#include <iostream>
class [[nodiscard]] Rational {               // siehe Text
public:
  Rational(long z, long n);          // OHNE Vorgabewerte

  // Abfragen
  [[nodiscard]] long getZaehler() const;
  [[nodiscard]] long getNenner() const;

  // arithmetische Methoden für +=, -=, *=, /=,
  // (werden später durch überladene Operatoren ergänzt)
  void add(Rational r);
  void sub(Rational r);
  void mult(Rational r);
  void div(Rational r);

  // weitere Methoden
  void set(long zaehler, long nenner);
  void kehrwert();
  void kuerzen();
private:
  long zaehler, nenner;
};

// inline-Methoden
inline Rational::Rational(long z, long n) : zaehler{z}, nenner{n} {}
inline long Rational::getZaehler() const { return zaehler; }
inline long Rational::getNenner() const { return nenner; }

// Prototypen freier Funktionen
Rational add(Rational a, Rational b);
Rational sub(Rational a, Rational b);
Rational mult(Rational a, Rational b);
Rational div(Rational z, Rational n);
void eingabe(Rational& r);
void ausgabe(Rational r, std::ostream& = std::cout);
#endif

