// Klasse zur Implementierung eines Datentyps für Mengen mit int-Elementen
#ifndef IntMenge_h
#define IntMenge_h
#include <vector>

class IntMenge {
public:
  IntMenge();
  void hinzufuegen(int el);
  void entfernen(int el);
  [[nodiscard]] bool istMitglied(int el) const;
  [[nodiscard]] int size() const;
  void anzeigen() const;
  void loeschen();             // alle Elemente löschen
  [[nodiscard]] int getMax() const;          // größtes Element
  [[nodiscard]] int getMin() const;          // kleinstes Element
private:
  int anzahl{0};
  std::vector<int> vec;
  // Die Hilfsfunktion finden() gibt die Position des
  // Elements zurück. -1 bedeutet nicht vorhanden
  [[nodiscard]] int finden(int el) const;
};
#endif
