// Die Funktion entspricht der Funktion strdup() der
// C++-Standardbibliothek.
#include <cstring>
#include <iostream>

[[nodiscard]] char* strduplikat(const char* s)
{
  // liefert einen Zeiger auf den neu erzeugten String.
  // ACHTUNG: Der Aufrufer ist für das delete [] verantwortlich!
  auto anzahl = strlen(s) + 1;
  char* neu = new char[anzahl];
  std::strncpy(neu, s, anzahl); 
  return neu;
}

int main()
{
  const char* const original = "Alles Gute!";
  std::cout << original << '\n';
  char* kopie = strduplikat(original);
  std::cout << kopie << '\n';
  delete[] kopie;          // nicht vergessen
}
