#include "Meinstring.h"
#include <cassert>
#include <cstring>          // strlen()

// Der allgemeine Konstruktor erzeugt aus einem klassischen C-String
// ein MeinString-Objekt.

MeinString::MeinString(const char* s)          // allg. Konstruktor
  : daten(s, s + std::strlen(s) + 1)           // +1 wg Nullbyte
{ }

MeinString& MeinString::assign(const char* s)  // Zuweisung eines C-Strings
{
  MeinString temp(s);          // Objekt ausreichender Größe schaffen
  swap(temp);                  // vertauschen
  return *this;
}

char& MeinString::at(IndexType position)  // Zeichen per Referenz holen
{
  assert(position < length());          // Nullbyte lesen ist nicht erlaubt
  return daten[position];
}

const char& MeinString::at(IndexType position) const  // Zeichen holen
{
  assert(position < length());          // Nullbyte lesen ist nicht erlaubt
  return daten[position];
}

void MeinString::swap(MeinString& mString)
{
  std::swap(daten, mString.daten);          // Bibliotheksfunktion
}

void MeinString::insert(IndexType pos, const MeinString& m)
{
  auto len = length();                  // alten Wert von length() retten
  if (pos > len) {                     // zu groß
    pos = len;                         // begrenzen, d.h. am Ende einfügen
  }
  auto neuesende = len + m.length();
  daten.resize(neuesende + 1);          // Platz schaffen und mit Nullbytes
                                        // auffüllen, falls notwendig,
  // Auf pos folgende Zeichen verschieben, um Platz zu schaffen:
  for (auto anz = 0z; anz <= len - pos; ++anz) {
    daten[neuesende] = daten[neuesende - m.length()];
    --neuesende;
  }
  // m einfügen
  for (auto i = 0z; i < m.length(); ++i) {
    daten[pos + i] = m.at(i);
  }
  // alternativ: copy() mit #include <algorithm>, siehe ggf Register:
  // std::copy(m.c_str(), m.c_str() + m.length(), daten.begin() +
  // pos);
}

void anzeigen(std::ostream& os, const MeinString& m) { os << m.data(); }


