#ifndef MEINSTRING_H
#define MEINSTRING_H
#include <cstddef>
#include <iostream>          // ostream
#include <vector>
using IndexType = std::ptrdiff_t;

class MeinString {
public:
  explicit MeinString(const char* str = "");       // allg. Konstruktor
  MeinString& assign(const char*);                 // Zuweisung eines C-Strings
  const char& at(IndexType position) const;        // Zeichen holen
  char& at(IndexType position);                    // Zeichen holen
          // Wegen des Rückgabetyps Referenz kann das Zeichen geändert werden.
  [[nodiscard]] auto length() const { return std::ssize(daten) - 1; }  // Zeichenzahl
  [[nodiscard]] auto data() const { return daten.data(); }    // Zeiger auf Inhalt
  void swap(MeinString&);                          // vertauschen
  [[nodiscard]] auto begin() const { return daten.begin(); }
  [[nodiscard]] auto end() const { return daten.end() - 1; } // -1 wegen Nullbyte

  // Zur Aufgabe:
  void insert(IndexType pos, const MeinString& m);
private:
  std::vector<char> daten;
};

void anzeigen(std::ostream& os, const MeinString& m);

#endif

